"Zope ODBC Database Connection"

import string

import Shared.DC.ZRDB.THUNK
TM = Shared.DC.ZRDB.THUNK.THUNKED_TM

from odbc import odbc

from DateTime import DateTime

type_mapping = {
    'STRING' : 's',
    'NUMBER' : 'i',
    'DATE'   : 'd',
}

class DB( TM ) :

    def __init__( self, connection_string ) :
        if connection_string.find( '/' ) == -1:
            connection_string = connection_string.replace( ' ', '/' )
        self.db = odbc( connection_string )
        self.cursor = self.db.cursor()
    
    def _begin( self) :
        pass
	
    def _finish( self) :
        self.db.commit()

    def _abort( self) :
        pass
    
    def query( self, query_string, max_rows=100000 ) :
        self._register()

        description = []
        result = []

        queries = [ q.strip() for q in query_string.split('\0') ]

        for query in queries:
            self.cursor.execute( query )
            if self.cursor.description:
                description = self.cursor.description
                result = self.cursor.fetchmany( max_rows )
                break

        result = [ list(row) for row in list(result) ]

        items = []
        index = 0
        for d in description :
            col_type = type_mapping[ d[1] ]
            if col_type == 'd':
                for row in result:
                    if row[index] != None: # thanks to Florian Reiser
                        row[index] = DateTime( str( row[index] ) )
            items.append(
                { "name"  : d[0],
                  "type"  : col_type,
                  "width" : d[4],
                  "null"  : d[6],
                }
            )
            index += 1
	
        return ( items, result )